# Generated by Django 4.2 on 2023-06-05 10:39

import common.utils
import datetime
from django.conf import settings
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("projects", "0014_project_description"),
    ]

    operations = [
        migrations.CreateModel(
            name="DailyAllowance",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "location_type",
                    models.CharField(
                        choices=[
                            ("urban", "Urban"),
                            ("rural", "Rural"),
                            ("metro", "Metropolitan"),
                        ],
                        max_length=100,
                    ),
                ),
                ("day_rate", models.DecimalField(decimal_places=2, max_digits=10)),
                ("night_rate", models.DecimalField(decimal_places=2, max_digits=10)),
                ("date", models.DateField(default=datetime.date(2023, 6, 5))),
                (
                    "currency",
                    models.CharField(
                        choices=[("INR", "Indian Rupee"), ("EUR", "Euro")],
                        max_length=10,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Forex",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("date", models.DateField(default=datetime.date(2023, 6, 5))),
                (
                    "currency",
                    models.CharField(
                        choices=[("INR", "Indian Rupee"), ("EUR", "Euro")],
                        max_length=10,
                    ),
                ),
                (
                    "value",
                    models.DecimalField(decimal_places=2, default=0, max_digits=10),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Proof",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("date", models.DateField(default=datetime.date(2023, 6, 5))),
                (
                    "document",
                    models.FileField(
                        blank=True,
                        default=None,
                        null=True,
                        upload_to=common.utils.UploadToPathAndRename(
                            "missions/", "documents"
                        ),
                        validators=[
                            django.core.validators.FileExtensionValidator(
                                ["jpg", "jpeg", "png", "pdf"]
                            ),
                            common.utils.MaxSizeValidator("10MB"),
                        ],
                    ),
                ),
                (
                    "amount",
                    models.DecimalField(decimal_places=2, default=0, max_digits=10),
                ),
                (
                    "currency",
                    models.CharField(
                        choices=[("INR", "Indian Rupee"), ("EUR", "Euro")],
                        max_length=10,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Mission",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("from_date", models.DateField(blank=True, null=True)),
                ("to_date", models.DateField(blank=True, null=True)),
                (
                    "currency",
                    models.CharField(
                        choices=[("INR", "Indian Rupee"), ("EUR", "Euro")],
                        max_length=10,
                    ),
                ),
                ("location_name", models.CharField(max_length=255)),
                (
                    "location_type",
                    models.CharField(
                        choices=[
                            ("urban", "Urban"),
                            ("rural", "Rural"),
                            ("metro", "Metropolitan"),
                        ],
                        max_length=50,
                    ),
                ),
                ("total_budget", models.IntegerField(default=0)),
                ("upfront_amount", models.IntegerField(default=0)),
                (
                    "status",
                    models.CharField(
                        choices=[
                            ("proposed", "Proposed"),
                            ("validated", "Validated"),
                            ("approved", "Approved"),
                            ("completed", "Completed"),
                            ("reimbursed", "Reimbursed"),
                        ],
                        default="proposed",
                        max_length=50,
                    ),
                ),
                (
                    "members",
                    models.ManyToManyField(
                        blank=True,
                        null=True,
                        related_name="mission_members",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="projects.project",
                    ),
                ),
                (
                    "proofs",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="missions.proof"
                    ),
                ),
                (
                    "proposer",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
    ]
